#!/bin/bash

SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
OUTPUT_DIR="$2"
CFG_FILE="$3"
DEFAULT_CFG_FILE=UnrealTournament.ini

function add_iniKey() {
	crudini --set $OUTPUT_DIR/System/$CFG_FILE $1 __$2 $3
	# Warning: ugly hack with sed to allow multiple key instances + to remove space around '='
	sed -i "s/[[:space:]]*__$2[[:space:]]*=[[:space:]]*/$2=/g" 	$OUTPUT_DIR/System/$CFG_FILE
}

# !!Warning!! section is not considered
function del_iniKey() {
	sed -i "/[[:space:]]*$2[[:space:]]*=[[:space:]]*$3/d" $OUTPUT_DIR/System/$CFG_FILE
}

function add_ServerPackage() {
	add_iniKey 'Engine.GameEngine' ServerPackages $1
}

function del_ServerPackage() {
	del_iniKey 'Engine.GameEngine' ServerPackages $1
}

function add_ServerActors() {
	add_iniKey 'Engine.GameEngine' ServerActors $1
}

function del_ServerActors() {
	del_iniKey 'Engine.GameEngine' ServerActors $1
}

function install() {
	rsync -a  $SCRIPT_DIR/Help/		$OUTPUT_DIR/Help
	rsync -a  $SCRIPT_DIR/System/ 	$OUTPUT_DIR/System
	
	echo install ok
}

function enable() {

	
	echo enable ok
}

function disable() {

	
	echo disable ok
}


function show_help() {
	echo
	echo "Usage: $0 { install | enable | disable } <UT99_INSTALL_DIR> [<UT99_CONFIG_FILE>]"
	echo
}

function check_cfg_file() {
	if [ -z ${CFG_FILE} ]
	then
		echo "CFG_FILE is unset, setting it to $DEFAULT_CFG_FILE"
		CFG_FILE=$DEFAULT_CFG_FILE
	else
		echo "CFG_FILE is set to '$CFG_FILE'"
	fi

	if [ ! -f $OUTPUT_DIR/System/$CFG_FILE ]
	then
		echo "$OUTPUT_DIR/System/$CFG_FILE does not exist"
		show_help
		exit 9999 # die with error code 9999
	fi
}

function check_game_dir() {
	### Check if a directory does not exist ###
	if [ ! -d $OUTPUT_DIR ]
	then
		echo "incorrect <UT99_INSTALL_DIR>"
		show_help
		exit 9999 # die with error code 9999
	fi
}

case "$1" in
	'install')
			check_game_dir
			install
			;;
	'enable')
			check_game_dir
			check_cfg_file
			disable
			enable
			;;
	'disable')
			check_game_dir
			check_cfg_file
			disable
			;;
	*)
			show_help
			exit 1
			;;
esac

exit 0